#property copyright "PipDefender - by Lorenzo Borrelli - 2010"
#property link "ellebimail@gmail.com"

#import "pipdlib.dll"
   double CalcProfit ( double p1[], double p2[] );   
   double OrderPrice ( double p1[] );
   int IsSafe ( double p1[] );
   void StealthMode( int p1[], double p2[], double p3[], int& p4[], double& p5[], double& p6[]);
   int SafeMode( int p1[], double p2[], double p3[], int p4 );
   void ManageProfit( int p1[], double p2[], double p3[], int& p4[], double& p5[], double& p6[]);   
#import "pipdlib.ex4"


// PIPDEFENDER CONST
#define PIPD_FALSE 0                   // "boolean" value for FALSE returned from dll functions
#define PIPD_TRUE 1                    // "boolean" value for TRUE returned from dll functions
#define PIPD_MODIFY -1                 // command action: "modify order" (sl & tp are passed separately)
#define PIPD_CLOSE -2                  // command action: "close order"
#define PIPD_ABORT  -3                 // ABORT command sent from the dll
#define PIPD_NOTHING -19740204         // command action: "no action"
#define PIPD_D_NOTHING -1974.0204      // double "null" value

// Other constants
#define _INDENT  "\n          "
#define _INDENT2 "   "
#define _PROMPT "====>       "
#define _SEPARATOR "----------------------------------------------------------------------"
#define _SEPARATOR2 "-----------------------------------------------------"
#define _ALL_OK 0                       // no exceptions, the EA continue to work normally
#define _ALERT -1                       // An "Alert" box will be shown, the EA suspend every other activity
#define _ABORT -2                       // An "Alert" box will be shown, the EA abort and will be removed from its chart
#define _SUSPEND -3                     // Special value used to avoid multiple Alert boxes
#define _CONTEXT_MAXTRY 5               // maximum number of consecutive retry for a context check
#define _CLOSE_MAXTRY 3                 // maximum number of consecutive retry for a CloseOrder function
#define _MODIFY_MAXTRY 3                // maximum number of consecutive retry for the ModifyOrder function
#define _BUSY_SLEEPTIME 500             // default sleeptime (milliseconds) for the sleep function (when the trade context is busy)
#define _5DIGITS_CURRENCY 5             // number of digits in a 5 digit currency
#define _4DIGITS_CURRENCY 4             // //
#define _3DIGITS_CURRENCY 3             // //
#define _2DIGITS_CURRENCY 2             // //
#define _4DIGITS_POINT 0.00010000       // point value for a 5&4 digit currencies
#define _2DIGITS_POINT 0.01000000       // point value for a 3&2 digit currencies

// INDEXES NAMES atart with the _ character
// FLAGS array indexes
#define _FIBONACCI_MODE 0
#define _GREEDY_MODE 1
#define _STEALTH_MODE 2
#define _SAFE_MODE 3
#define _SHOW_INFO_PANEL 4
#define _PRINT_LOG 5
// PARAMS array indexes
#define _TRAILING_STOP 0
#define _GREEDY_LEVEL 1  // int
#define _TRUE_SL 2
#define _FAKE_TP 3
#define _FAKE_SL 4
#define _MAX_HOURS_WARNING 5
#define _MAX_HOURS_ALARM 6
#define _SAFE_LOSS 7
#define _CLOSE_SLIPPAGE 8
#define _POINT_VALUE 9
#define _X_STOPLEVEL 10
// ORDER array indexes
#define _O_TICKET 0	// int
#define _O_TYPE 1	// int
#define _M_BID 2
#define _M_ASK 3
#define _O_OPENPRICE 4
#define _O_OPENTIME 5	// int
#define _O_TAKEPROFIT 6
#define _O_STOPLOSS 7
#define _O_PROFIT 8

// -------------------------------------------------------------------------------------------------------------------------------
// EXTERNAL PARAMETERS
// -------------------------------------------------------------------------------------------------------------------------------
extern string VERSION = "1.0beta8";
extern bool FIBONACCI_MODE = false;    // true for Fibonacci mode on
// --- Standard mode parameters
extern string _____Standard_mode_parameters = _SEPARATOR;
extern double TRAILING_STOP = 4.0;     // PIP
extern bool GREEDY_MODE = true;        // Enable or disable the greedy mode
extern int GREEDY_LEVEL = 2;           // number of TS interval to be managed with the classic trailing top algorithm
// --- Stealth mode parameters
extern string _____Stealth_mode_parameters = _SEPARATOR;
extern bool STEALTH_MODE = true;       // Enable or disable the internal SL management
extern double TRUE_SL = 40.0;          // PIP
extern double FAKE_TP = 50.0;          // PIP
extern double FAKE_SL = 150.0;         // PIP
// --- Safe mode parameters string
extern string _____Safe_mode_parameters = _SEPARATOR;
extern bool SAFE_MODE = true;          // Enable or disable the safe mode
extern double MAX_HOURS_WARNING = 8.0;
extern double MAX_HOURS_ALARM = 16.0;
extern double SAFE_LOSS = 4.0;         // Max "safe" PIP loss after MAX_HOURS
extern string _____Other_parameters = _SEPARATOR;
extern double CLOSE_SLIPPAGE = 3.0;    // PIP
// --- Additional stuff
extern string _____Additional_stuff = _SEPARATOR;
extern bool SHOW_INFO_PANEL = true;    // Enable or disable the info panel
extern bool PRINT_LOG = true; // Enable or disable log messages 
extern string EXCLUDE_LIST = "";       // comma separated list of magic numbers 

int FLAGS[6];
double PARAMS[11];

// NUMERIC
double NormalizeDigits( double value );
string DoubleDigitsToString( double value );
string DoubleOneDigitToString( double price );

// UTILITY
void Tokenize(int& output[], string input, string token);
void LineFeed();
void ClrScr();
void Cout( string text );
void CoutF( string text );
void Die();